{ lib
, buildGoModule
, fetchFromGitHub
, installShellFiles
}:

let version = "2022-12-08"; in

buildGoModule {
  pname = "d2";
  inherit version;

  src = fetchFromGitHub {
    owner = "terrastruct";
    repo = "d2";
    rev = "4f49cf6426c0925d238bb35424ebb1e6165b6054";
    sha256 = "sha256-LvHffBZD6+Y2XTtnnQk1gFN8RPEN82A0AJkH4Jc7RMY=";
  };

  vendorSha256 = "sha256-p0os+ap2k5nYWI4+Hf4pwJfHTXaPJldJmf6nznhuRFA=";

  ldflags = [
    "-s"
    "-w"
    "-X oss.terrastruct.com/d2/lib/version.Version=${version}"
  ];

  nativeBuildInputs = [ installShellFiles ];

  patches = [ ];

  postInstall = "installManPage ci/release/template/man/d2.1";

  subPackages = [ "." ];
}
